Index: trunk/VUT/work/ogre_changes/RenderSystems/GL/include/OgreGLHardwareOcclusionQuery.h
===================================================================
--- trunk/VUT/work/ogre_changes/RenderSystems/GL/include/OgreGLHardwareOcclusionQuery.h	(revision 88)
+++ trunk/VUT/work/ogre_changes/RenderSystems/GL/include/OgreGLHardwareOcclusionQuery.h	(revision 88)
@@ -0,0 +1,132 @@
+/*
+-----------------------------------------------------------------------------
+This source file is part of OGRE
+    (Object-oriented Graphics Rendering Engine)
+For the latest info, see http://ogre.sourceforge.net/
+
+Copyright (c) 2000-2005 The OGRE Team
+Also see acknowledgements in Readme.html
+
+This program is free software; you can redistribute it and/or modify it under
+the terms of the GNU Lesser General Public License as published by the Free Software
+Foundation; either version 2 of the License, or (at your option) any later
+version.
+
+This program is distributed in the hope that it will be useful, but WITHOUT
+ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
+
+You should have received a copy of the GNU Lesser General Public License along with
+this program; if not, write to the Free Software Foundation, Inc., 59 Temple
+Place - Suite 330, Boston, MA 02111-1307, USA, or go to
+http://www.gnu.org/copyleft/lesser.txt.
+-----------------------------------------------------------------------------
+*/
+
+/*
+The nVidia occlusion query extension is defined in glext.h so you don't 
+need anything else. You do need to look up the function, we provide a 
+GLSupport class to do this, which has platform implementations for 
+getProcAddress. Check the way that extensions like glActiveTextureARB are 
+initialised and used in glRenderSystem and copy what is done there.
+
+
+
+  To do: fix so dx7 and DX9 checks and flags if HW Occlusion is supported
+  See the openGl dito for ideas what to do.
+
+*/
+
+
+
+//GL_ActiveTextureARB_Func* glActiveTextureARB_ptr = (GL_ActiveTextureARB_Func)mGLSupport->getProcAddress("glActiveTextureARB");
+
+#ifndef __GLHARDWAREOCCLUSIONQUERY_H__
+#define __GLHARDWAREOCCLUSIONQUERY_H__
+
+#include "OgreGLPrerequisites.h"
+#include "OgreHardwareOcclusionQuery.h"
+
+
+namespace Ogre { 
+
+
+// If you use multiple rendering passes you can test only the first pass and all other passes don't have to be rendered 
+// if the first pass resultet has too few pixels visable.
+
+// Be sure to render all occlluder first and whats out so the RenderQue don't switch places on 
+// the occluding objects and the tested objects because it thinks it's more effective..
+
+
+/**
+  * This is a class that is the base class of the query class for 
+  * hardware occlusion.
+  *
+  * @author Lee Sandberg email: lee@abcmedia.se
+  */
+
+class GLHardwareOcclusionQuery : public HardwareOcclusionQuery
+{
+//----------------------------------------------------------------------
+// Public methods
+//--
+public:
+	/**
+	  * Default object constructor
+	  * 
+	  */
+	GLHardwareOcclusionQuery();
+	/**
+	  * Object destructor
+	  */
+	~GLHardwareOcclusionQuery();
+
+	//------------------------------------------------------------------
+	// Occlusion query functions (see base class documentation for this)
+	//--
+
+	void beginOcclusionQuery();
+	void endOcclusionQuery();
+	bool pullOcclusionQuery( unsigned int* NumOfFragments, const bool waitForResult );
+	bool pullOcclusionQuery( unsigned int* NumOfFragments, const bool waitForResult,
+							 const HW_OCCLUSIONQUERY flag  ); 
+
+	unsigned int getLastQuerysPixelcount() { return m_uintPixelCount; }
+
+	// This functions are optional, it's a simple filter that simply skipps some hardware occlusion tests on visable objects only
+	// It's easy to use if you don't have to keep track on which objects are visable (can be skipped) and what objects arn't visable..
+	// (None visable objects and object you introduce for the first time have allways to be tested allthough the cheepest possible 
+	// LOD (Level Of Detail) mesh and material wize). 
+
+	/**
+	  *   
+	  * Remarks This function allows you to set how often the hardware occlusion really sent to the driver
+	  * if you set it to 0 every hw occlusion test is acctually made. If you set it to 2 only 50% of your queries are sent. 
+	  * for all visable objects. 3 will result in 33% of all queries to acctualy be sent and so on. 
+	  * New and none visable objects will be tested all the time.
+	  * This functionality is here because this class can keep track on visable and none visable objects for you.
+	  * Once you you set the SkipRate for any hardware occlusion instance it effects all others.
+	  */
+
+	void setSkipRate( int skip ) { m_Skip = skip; }		// Using 2 only 50 % of the tests are actully made and 3 results in only 33% of the tests. So on.
+	int	 getSkipRate() { return m_Skip; } 
+
+
+//----------------------------------------------------------------------
+// Protected members
+//--
+protected:
+
+	unsigned int	m_uintPixelCount;
+	unsigned int	m_uintQuery[1];
+	bool			m_bOcclusionQuery;
+	int				m_SkipCounter;		// m_SkipConter =  m_SkipConter % m_Skip; if ( m_SkipConter == 0 && m_uintPixelCount !=0 ) TestHWOcclusion else just return 
+	static int		m_Skip;				// This is shared by all instancies
+	bool			m_bHWOcclusionSupport;
+};
+
+
+}
+
+#endif 
+
Index: trunk/VUT/work/ogre_changes/RenderSystems/GL/src/OgreGLHardwareOcclusionQuery.cpp
===================================================================
--- trunk/VUT/work/ogre_changes/RenderSystems/GL/src/OgreGLHardwareOcclusionQuery.cpp	(revision 88)
+++ trunk/VUT/work/ogre_changes/RenderSystems/GL/src/OgreGLHardwareOcclusionQuery.cpp	(revision 88)
@@ -0,0 +1,148 @@
+/*
+-----------------------------------------------------------------------------
+This source file is part of OGRE
+    (Object-oriented Graphics Rendering Engine)
+For the latest info, see http://ogre.sourceforge.net/
+
+Copyright (c) 2000-2005 The OGRE Team
+Also see acknowledgements in Readme.html
+
+This program is free software; you can redistribute it and/or modify it under
+the terms of the GNU Lesser General Public License as published by the Free Software
+Foundation; either version 2 of the License, or (at your option) any later
+version.
+
+This program is distributed in the hope that it will be useful, but WITHOUT
+ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
+
+You should have received a copy of the GNU Lesser General Public License along with
+this program; if not, write to the Free Software Foundation, Inc., 59 Temple
+Place - Suite 330, Boston, MA 02111-1307, USA, or go to
+http://www.gnu.org/copyleft/lesser.txt.
+-----------------------------------------------------------------------------
+*/
+
+#include "OgreGLHardwareOcclusionQuery.h"
+#include "OgreException.h"
+
+namespace Ogre {
+
+int GLHardwareOcclusionQuery::m_Skip = 0;
+
+/**
+  * This is a class that is the base class of the query class for 
+  * hardware occlusion testing.
+  *
+  * @author Lee Sandberg email: lee@abcmedia.se
+  */
+
+/* Functions used;
+
+glGenOcclusionQueriesNV_ptr( 1, m_uintQuery );
+glDeleteOcclusionQueriesNV_ptr( 1, &m_uintQuery[0] );
+glBeginOcclusionQueryNV_ptr( m_uintQuery[0] );
+glEndOcclusionQueryNV_ptr();
+glGetOcclusionQueryuivNV_ptr( m_uintQuery[0], GL_PIXEL_COUNT_NV, NumOfFragments );
+
+  TO DO: change this to the new ARB functions...
+
+*/
+
+
+/**
+  * Default object constructor
+  * 
+  */
+GLHardwareOcclusionQuery::GLHardwareOcclusionQuery() 
+{ 
+	m_uintPixelCount = 0; 
+	m_SkipCounter = 0;
+
+	// Check for hardware occlusion support
+    if( glDeleteOcclusionQueriesNV_ptr != 0 )	// This is a hack to see if hw occlusion is supported. pointer is 0 if it's not supported.
+    {
+		m_bHWOcclusionSupport = true;
+	}
+	else
+	{
+		m_bHWOcclusionSupport = false;
+	}
+
+	if( m_bHWOcclusionSupport )
+	{
+		glGenOcclusionQueriesNV_ptr( 1, m_uintQuery );	
+	}
+}
+
+
+/**
+  * Object destructor
+  */
+GLHardwareOcclusionQuery::~GLHardwareOcclusionQuery() 
+{ 
+	if( m_bHWOcclusionSupport )
+	{
+		glDeleteOcclusionQueriesNV_ptr( 1, &m_uintQuery[0] );  
+	}	
+}
+
+//------------------------------------------------------------------
+// Occlusion query functions (see base class documentation for this)
+//--
+void GLHardwareOcclusionQuery::beginOcclusionQuery() 
+{ 
+	if( m_bHWOcclusionSupport )	// Make it fail silently if hardware occlusion isn't supported
+	{
+		glBeginOcclusionQueryNV_ptr( m_uintQuery[0] );
+	}
+}
+	
+void GLHardwareOcclusionQuery::endOcclusionQuery() 
+{ 
+	if( m_bHWOcclusionSupport )	// Make it fail silently if hardware occlusion isn't supported
+	{
+		glEndOcclusionQueryNV_ptr();
+	}
+}
+
+bool GLHardwareOcclusionQuery::pullOcclusionQuery( unsigned int * NumOfFragments, const bool waitForResult) 
+{
+	unsigned int isAvailable = GL_TRUE;
+
+	if( m_bHWOcclusionSupport )	
+	{
+		if(!waitForResult)
+		{
+			glGetOcclusionQueryuivNV_ptr( m_uintQuery[0], GL_PIXEL_COUNT_AVAILABLE_NV, &isAvailable );
+		}
+
+		if(isAvailable == GL_TRUE)
+		{
+			glGetOcclusionQueryuivNV_ptr( m_uintQuery[0], GL_PIXEL_COUNT_NV, NumOfFragments );
+		}
+	} 
+	else
+	{
+		// In case hardware occlusion isn't supported, every object is set visible.
+		*NumOfFragments = 100000;		
+	}
+
+	m_uintPixelCount = *NumOfFragments; 
+
+	return isAvailable == GL_TRUE;	
+}
+
+//------------------------------------------------------------------
+// OpenGL doesn't use the flag, but to implement the abstract interface we need to include this function.
+// Using this function in OpenGL mode simple works the same way as calling the other function without the flag parameter,
+// but in DX9 it works differentlly, see notes in the DX9 implementation.
+//--
+bool GLHardwareOcclusionQuery::pullOcclusionQuery( unsigned int* NumOfFragments, const bool waitForResult, const HW_OCCLUSIONQUERY flag  ) 
+{
+	return pullOcclusionQuery(NumOfFragments, waitForResult);
+}
+
+}
+
+
Index: trunk/VUT/work/ogre_changes/RenderSystems/Direct3D9/include/OgreD3D9HardwareOcclusionQuery.h
===================================================================
--- trunk/VUT/work/ogre_changes/RenderSystems/Direct3D9/include/OgreD3D9HardwareOcclusionQuery.h	(revision 88)
+++ trunk/VUT/work/ogre_changes/RenderSystems/Direct3D9/include/OgreD3D9HardwareOcclusionQuery.h	(revision 88)
@@ -0,0 +1,119 @@
+/*
+-----------------------------------------------------------------------------
+This source file is part of OGRE
+    (Object-oriented Graphics Rendering Engine)
+For the latest info, see http://ogre.sourceforge.net/
+
+Copyright (c) 2000-2005 The OGRE Team
+Also see acknowledgements in Readme.html
+
+This program is free software; you can redistribute it and/or modify it under
+the terms of the GNU Lesser General Public License as published by the Free Software
+Foundation; either version 2 of the License, or (at your option) any later
+version.
+
+This program is distributed in the hope that it will be useful, but WITHOUT
+ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
+
+You should have received a copy of the GNU Lesser General Public License along with
+this program; if not, write to the Free Software Foundation, Inc., 59 Temple
+Place - Suite 330, Boston, MA 02111-1307, USA, or go to
+http://www.gnu.org/copyleft/lesser.txt.
+-----------------------------------------------------------------------------
+*/
+
+#ifndef _D3D9HARWAREOCCLUSIONQUERY_H__
+#define _D3D9HARWAREOCCLUSIONQUERY_H__
+
+#include "OgreD3D9Prerequisites.h"
+#include "OgreHardwareOcclusionQuery.h"
+
+
+namespace Ogre {
+
+
+
+// If you use multiple rendering passes you can test only the first pass and all other passes don't have to be rendered 
+// if the first pass resultet has too few pixels visable.
+
+// Be sure to render all occlluder first and whats out so the RenderQue don't switch places on 
+// the occluding objects and the tested objects because it thinks it's more effective..
+
+/**
+  * This is a class that is the DirectX9 implementation of 
+  * hardware occlusion testing.
+  *
+  * @author Lee Sandberg, email lee@abcmedia.se
+  */
+class D3D9HardwareOcclusionQuery : public HardwareOcclusionQuery
+{
+//----------------------------------------------------------------------
+// Public methods
+//--
+public:
+
+	/**
+	  * Default object constructor
+	  * 
+	  */
+	D3D9HardwareOcclusionQuery( IDirect3DDevice9* pD3DDevice );
+
+	/**
+	  * Object destructor
+	  */
+	~D3D9HardwareOcclusionQuery();
+
+	//------------------------------------------------------------------
+	// Occlusion query functions (see base class documentation for this)
+	//--
+
+	void beginOcclusionQuery();	
+	void endOcclusionQuery();
+	bool pullOcclusionQuery( unsigned int* NumOfFragments, const bool waitForResult );
+	bool pullOcclusionQuery( unsigned int* NumOfFragments, const bool waitForResult,
+							 const HW_OCCLUSIONQUERY flag  ); 
+
+	unsigned int getLastQuerysPixelcount() { return m_uintPixelCount; }
+	
+	// This functions are optional, it's a simple filter that simply skips some hardware occlusion tests on visable objects only
+	// It's easy to use if you don't have to keep track on which objects are visable (can be skipped) and what objects arn't visable..
+	// (None visable objects and object you introduce for the first time have allways to be tested allthough the cheepest possible 
+	// LOD (Level Of Detail) mesh and material wize). 
+
+	/**
+	  *   
+	  * Remarks This function allows you to set how often the hardware occlusion really are sent to the driver
+	  * if you set it to 0 every hw occlusion test is acctually made. If you set it to 1 only the half of your queries are sent 
+	  * for all visable objects. 2 will result in 25% of all queries to acctualy be sent. 
+	  * New and none visable objects will be tested all the time.
+	  * This functionality is here because this class can keep track on visable and none visable objects for you.
+	  * Once you you set the SkipRate for any hardware occlusion instance it effects all others.
+	  */
+
+
+	void setSkipRate( int skip ) { m_Skip = skip; }			// Using 2 only 50 % of the tests are actually made and 3 results in only 33% of the tests. So on.
+	int	 getSkipRate() { return m_Skip; } 
+
+//----------------------------------------------------------------------
+// Protected members
+//--
+protected:
+
+	bool pullOcclusionQuery( unsigned int* NumOfFragments, const bool waitForResult, 
+						     const DWORD queryFlag );
+
+	unsigned int		m_uintPixelCount;		
+	IDirect3DQuery9*	m_pD3DQuery;
+	IDirect3DDevice9*   m_pD3DDevice;       // d3d device
+	bool				m_bOcclusionQuery;
+	int					m_SkipCounter;		// m_SkipConter =  m_SkipConter % m_Skip; if ( m_SkipConter == 0 && m_uintPixelCount !=0 ) TestHWOcclusion else just return 
+	static int			m_Skip;				// This is shared by all instancies
+	bool				m_bHWOcclusionSupport;
+};
+
+
+}
+
+
+#endif
Index: trunk/VUT/work/ogre_changes/RenderSystems/Direct3D9/src/OgreD3D9HardwareOcclusionQuery.cpp
===================================================================
--- trunk/VUT/work/ogre_changes/RenderSystems/Direct3D9/src/OgreD3D9HardwareOcclusionQuery.cpp	(revision 88)
+++ trunk/VUT/work/ogre_changes/RenderSystems/Direct3D9/src/OgreD3D9HardwareOcclusionQuery.cpp	(revision 88)
@@ -0,0 +1,139 @@
+/*
+-----------------------------------------------------------------------------
+This source file is part of OGRE
+    (Object-oriented Graphics Rendering Engine)
+For the latest info, see http://ogre.sourceforge.net/
+
+Copyright (c) 2000-2005 The OGRE Team
+Also see acknowledgements in Readme.html
+
+This program is free software; you can redistribute it and/or modify it under
+the terms of the GNU Lesser General Public License as published by the Free Software
+Foundation; either version 2 of the License, or (at your option) any later
+version.
+
+This program is distributed in the hope that it will be useful, but WITHOUT
+ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
+FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
+
+You should have received a copy of the GNU Lesser General Public License along with
+this program; if not, write to the Free Software Foundation, Inc., 59 Temple
+Place - Suite 330, Boston, MA 02111-1307, USA, or go to
+http://www.gnu.org/copyleft/lesser.txt.
+-----------------------------------------------------------------------------
+*/
+#include "OgreD3D9HardwareOcclusionQuery.h"
+#include "OgreRenderSystemCapabilities.h"
+#include "OgreException.h"
+
+namespace Ogre {
+
+int D3D9HardwareOcclusionQuery::m_Skip = 0;
+
+/**
+  * This is a class that is the DirectX9 implementation of 
+  * hardware occlusion testing.
+  *
+  * @author Lee Sandberg
+  */
+
+/**
+  * Default object constructor
+  * 
+  */
+D3D9HardwareOcclusionQuery::D3D9HardwareOcclusionQuery( IDirect3DDevice9* pD3DDevice ) 
+{ 
+	m_pD3DDevice = pD3DDevice;
+	m_uintPixelCount = 0; 
+	m_SkipCounter = 0;
+	m_bHWOcclusionSupport = false;
+
+	HRESULT hr = m_pD3DDevice->CreateQuery(D3DQUERYTYPE_OCCLUSION, &m_pD3DQuery);
+	if ( hr != D3D_OK ) 
+	{
+		//OGRE_EXCEPT(hr, "D3D9HardwareOcclusionQuery couldn't create hardware occlusion query object.", 
+        //        "D3D9HardwareOcclusionQuery::D3D9HardwareOcclusionQuery");
+		m_bHWOcclusionSupport = false;
+	}
+	else 
+	{
+		m_bHWOcclusionSupport = true;
+	}
+}
+
+
+/**
+  * Object destructor
+  */
+D3D9HardwareOcclusionQuery::~D3D9HardwareOcclusionQuery() 
+{ 
+	SAFE_RELEASE( m_pD3DQuery ); 
+}
+
+//------------------------------------------------------------------
+// Occlusion query functions (see base class documentation for this)
+//--
+void D3D9HardwareOcclusionQuery::beginOcclusionQuery() 
+{ 
+	if( m_bHWOcclusionSupport )		// Make it fail silently if hardware occlusion isn't supported
+	{
+		m_pD3DQuery->Issue(D3DISSUE_BEGIN); 
+	}
+}
+//------------------------------------------------------------------
+void D3D9HardwareOcclusionQuery::endOcclusionQuery() 
+{ 
+	if( m_bHWOcclusionSupport )	// Make it fail silently if hardware occlusion isn't supported
+	{
+		m_pD3DQuery->Issue(D3DISSUE_END); 
+	}
+}
+
+//------------------------------------------------------------------
+// This version of pullOcclusionQuery cases the DX9 API/Driver to flush all commands to the 3D card
+// to allow a fast result from the query, but at the cost of poorer batching of API calls to the card.
+// Note: OpenGL dosn't use this flag at all so the application running OpenGL won't display any different behaviour.
+//--
+bool D3D9HardwareOcclusionQuery::pullOcclusionQuery( unsigned int* NumOfFragments, const bool waitForResult ) 
+{
+	return pullOcclusionQuery(NumOfFragments, waitForResult, HWOCCLUSIONQUERY_FLUSH);
+}
+
+//------------------------------------------------------------------
+// This version of pullOcclusionQuery cases the DX9 API/Driver to not flush all commands to the 3D card
+// to allow a fast result from the query, but the batching of API calls to the card will be normal. 
+// But the query wont be processed until the card recives the query in the nexr batch.
+// Note: OpenGL dosn't use this flag at all so the application running OpenGL won't display any different behaviour.
+//--
+bool D3D9HardwareOcclusionQuery::pullOcclusionQuery( unsigned int* NumOfFragments, const bool waitForResult, 
+												     const HW_OCCLUSIONQUERY flag  ) 
+{
+	DWORD queryFlag = flag == HWOCCLUSIONQUERY_FLUSH ? D3DGETDATA_FLUSH : 0;
+	// TO DO: USE lockOpts= D3D9Mappings::get(options); instead of RS_OCCLUSIONQUERY enum
+
+	return pullOcclusionQuery(NumOfFragments, waitForResult, queryFlag);
+}
+//------------------------------------------------------------------
+bool D3D9HardwareOcclusionQuery::pullOcclusionQuery( unsigned int* NumOfFragments, const bool waitForResult, 
+												     const DWORD queryFlag ) 
+{
+	HRESULT hr = S_OK;
+
+	if( m_bHWOcclusionSupport )	// In case hardware occlusion isn't supported
+	{	
+		do
+		{
+			hr = m_pD3DQuery->GetData( NumOfFragments, sizeof( NumOfFragments ), queryFlag );
+	    	}
+		while(waitForResult && (hr == S_FALSE));
+		
+		m_uintPixelCount = *NumOfFragments; 
+	}
+	else
+	{
+		m_uintPixelCount = 100000; // every object is visible
+	}
+	
+	return hr == S_OK;
+}
+} // namespace OGre