Index: trunk/VUT/GtpVisibility/src/FrustumCullingManager.cpp
===================================================================
--- trunk/VUT/GtpVisibility/src/FrustumCullingManager.cpp	(revision 87)
+++ trunk/VUT/GtpVisibility/src/FrustumCullingManager.cpp	(revision 94)
@@ -1,4 +1,4 @@
 #include "FrustumCullingManager.h"
-#include <windows.h>
+#include <OgreLogManager.h>
 
 namespace GtpVisibility {
@@ -8,5 +8,5 @@
 {
 	InitFrame();
-
+	Ogre::LogManager::getSingleton().logMessage("**** Frustum Culling ****\n");
 	while (!mHierarchyInterface->GetQueue()->empty())
 	{
Index: trunk/VUT/GtpVisibility/src/CoherentHierarchicalCullingManager.cpp
===================================================================
--- trunk/VUT/GtpVisibility/src/CoherentHierarchicalCullingManager.cpp	(revision 87)
+++ trunk/VUT/GtpVisibility/src/CoherentHierarchicalCullingManager.cpp	(revision 94)
@@ -1,4 +1,4 @@
 #include "CoherentHierarchicalCullingManager.h"
-#include <windows.h>
+#include <OgreLogManager.h>
 
 namespace GtpVisibility {
@@ -8,4 +8,5 @@
 {
 	InitFrame();
+	Ogre::LogManager::getSingleton().logMessage("**** CHCULL ****\n");
 
 	QueryQueue queryQueue;
@@ -20,7 +21,5 @@
 									mHierarchyInterface->GetQueue()->empty()))
 		{
-            //if (mHierarchyInterface->GetQueue()->empty())OutputDebugString("empty\n");
-								
-			HierarchyNode *node = queryQueue.front().first;
+           	HierarchyNode *node = queryQueue.front().first;
 						
 			queryQueue.pop();
Index: trunk/VUT/GtpVisibility/src/VisibilityManager.cpp
===================================================================
--- trunk/VUT/GtpVisibility/src/VisibilityManager.cpp	(revision 92)
+++ trunk/VUT/GtpVisibility/src/VisibilityManager.cpp	(revision 94)
@@ -9,10 +9,10 @@
 //-----------------------------------------------------------------------
 VisibilityManager::VisibilityManager(VisibilityEnvironment *visEnvironment):
-mVisibilityThreshold(0)
+mVisibilityThreshold(0), mCullingManager(NULL) 
 {
 	mVisibilityEnvironment = visEnvironment;
 	
-	mCullingManagerType = VisibilityEnvironment::STOP_AND_WAIT_CULLING;
-	mCullingManager = new StopAndWaitCullingManager();
+	SetCullingManager(VisibilityEnvironment::COHERENT_HIERARCHICAL_CULLING);
+	//SetCullingManager(VisibilityEnvironment::FRUSTUM_CULLING);
 
 	mQueryManager = new DummyQueryManager(0);
@@ -28,8 +28,10 @@
 	VisibilityEnvironment::CullingManagerType ocmType)
 {
-	if (mCullingManagerType != ocmType)
+	// change only if necessary
+	if (!mCullingManager || (mCullingManagerType != ocmType))
 	{
 		// delete old culling manager
-		delete mCullingManager;
+		if(mCullingManager)
+			delete mCullingManager;
 
 		mCullingManagerType = ocmType;
Index: trunk/VUT/GtpVisibility/src/StopAndWaitCullingManager.cpp
===================================================================
--- trunk/VUT/GtpVisibility/src/StopAndWaitCullingManager.cpp	(revision 92)
+++ trunk/VUT/GtpVisibility/src/StopAndWaitCullingManager.cpp	(revision 94)
@@ -1,4 +1,5 @@
 #include "StopAndWaitCullingManager.h"
-#include <windows.h>
+#include <OgreLogManager.h>
+
 
 namespace GtpVisibility {
@@ -8,5 +9,6 @@
 {
 	InitFrame();
-			
+	Ogre::LogManager::getSingleton().logMessage("*** STOP AND WAIT CULL ****\n");	
+
 	while (!mHierarchyInterface->GetQueue()->empty())
 	{
Index: trunk/VUT/work/TestCullingTerrain/TestCullingTerrainApplication.cpp
===================================================================
--- trunk/VUT/work/TestCullingTerrain/TestCullingTerrainApplication.cpp	(revision 93)
+++ trunk/VUT/work/TestCullingTerrain/TestCullingTerrainApplication.cpp	(revision 94)
@@ -17,5 +17,5 @@
 
 #define WIN32_LEAN_AND_MEAN
-#include "windows.h"
+#include <windows.h>
 
 
@@ -27,5 +27,5 @@
 	if(mTerrainContentGenerator)
 		delete mTerrainContentGenerator;
-	//if(mCullCamera) delete mCullCamera;
+	//if(mVisualizationCamera) delete mVisualizationCamera;
 }
 //-----------------------------------------------------------------------
@@ -33,5 +33,5 @@
 {
 	// Create the camera
-	mCamera = mSceneMgr->createCamera("PlayerCam");
+	mCamera = mSceneMgr->createCamera("CullCamera");
 	
 	// Set a nice viewpoint
@@ -40,9 +40,9 @@
 	
 	//--create cull camera
-	mCullCamera = mSceneMgr->createCamera("CullCamera");
-	mCullCamera->setPosition(707, 2500, 528);
-	mCullCamera->setOrientation(Quaternion(-0.3486, 0.0122, 0.9365, 0.0329));
-
-	mCullCamera->setNearClipDistance(1);
+	mVisualizationCamera = mSceneMgr->createCamera("VisualizationCamera");
+	mVisualizationCamera->setPosition(707, 2500, 528);
+	mVisualizationCamera->setOrientation(Quaternion(-0.3486, 0.0122, 0.9365, 0.0329));
+
+	mVisualizationCamera->setNearClipDistance(1);
 	mCamera->setNearClipDistance(1);
 
@@ -50,10 +50,10 @@
 	if (mRoot->getRenderSystem()->getCapabilities()->hasCapability(RSC_INFINITE_FAR_PLANE))
 	{
-		mCullCamera->setFarClipDistance(0);
+		mVisualizationCamera->setFarClipDistance(0);
 		mCamera->setFarClipDistance(0);
 	}
 	else
 	{
-		 mCullCamera->setFarClipDistance(1000);
+		 mVisualizationCamera->setFarClipDistance(1000);
 		 mCamera->setFarClipDistance(1000);
 	}
@@ -79,6 +79,5 @@
 	mWindow->getViewport(0)->setBackgroundColour(fadeColour);
 	//mSceneMgr->setFog( FOG_LINEAR, fadeColour, .001, 500, 1000);
-	mWindow->addViewport(mCullCamera, 10, 0.5, 0.5, 1, 1);
-
+	
 	// Create a skybox
     mSceneMgr->setSkyBox(true, "Examples/SpaceSkyBox", 5000, false);
@@ -133,5 +132,5 @@
 {
 	mFrameListener= new MouseQueryListener(mWindow, mCamera, mSceneMgr, 
-		mGUIRenderer, mTerrainContentGenerator, mCullCamera);
+		mGUIRenderer, mTerrainContentGenerator, mVisualizationCamera);
 	mFrameListener->showDebugOverlay(true);
 	mRoot->addFrameListener(mFrameListener);
@@ -150,5 +149,5 @@
 									   CEGUI::Renderer *renderer,
 									   TerrainContentGenerator *sceneGenerator,
-									   Camera *cullCamera): 
+									   Camera *vizCamera): 
 ExampleFrameListener(win, cam, false, true), 
 mGUIRenderer(renderer), 
@@ -163,7 +162,7 @@
 mShowOctree(false),
 mUseCulling(true),
-mUseOptimization(false),
+mUseOptimization(true),
 mUseCullCamera(false),
-mCullCamera(cullCamera)
+mVisualizationCamera(vizCamera)
 {
 	// Reduce move speed
@@ -293,25 +292,21 @@
 bool MouseQueryListener::frameStarted(const FrameEvent &evt)
 {
+	clamp2Terrain(mCamera);
+	clamp2Terrain(mVisualizationCamera);
+
+	return ExampleFrameListener::frameStarted(evt);
+}
+void MouseQueryListener::clamp2Terrain(Camera *cam)
+{
 	// clamp to terrain
-	Vector3 camPos = mCamera->getPosition();
+	Vector3 camPos = cam->getPosition();
 	Vector3 queryResult;
 
-    if(mRayQueryExecutor->executeRayQuery(&queryResult, 
-		Vector3(camPos.x, 5000.0f, camPos.z), Vector3::NEGATIVE_UNIT_Y))
+	if(mRayQueryExecutor->executeRayQuery(&queryResult, 
+			Vector3(camPos.x, 5000.0f, camPos.z), Vector3::NEGATIVE_UNIT_Y))
 	{
-		mCamera->setPosition(mCamera->getPosition().x, queryResult.y + 10, 
-			mCamera->getPosition().z);
+		cam->setPosition(cam->getPosition().x, queryResult.y + 10, 
+			cam->getPosition().z);
 	}
-
-	camPos = mCullCamera->getPosition();
-
-	if(mRayQueryExecutor->executeRayQuery(&queryResult, 
-		Vector3(camPos.x, 5000.0f, camPos.z), Vector3::NEGATIVE_UNIT_Y))
-	{
-		mCullCamera->setPosition(mCullCamera->getPosition().x, queryResult.y + 10, 
-			mCullCamera->getPosition().z);
-	}
-
-	return ExampleFrameListener::frameStarted(evt);
 }
 //-----------------------------------------------------------------------
@@ -332,7 +327,8 @@
 	KEY_PRESSED(KC_C, 0.3, toggleUseCulling());
 	KEY_PRESSED(KC_V, 0.3, toggleCullCamera());
-	KEY_PRESSED(KC_X, 0.3, fixCullCamera());
+	KEY_PRESSED(KC_X, 0.3, FixVizCamera());
 
 	updateStats();
+	//if(mWindow->getViewport(1))	mWindow->getViewport(1)->update();
 
     return ExampleFrameListener::frameStarted(evt) && ExampleFrameListener::frameEnded(evt);        
@@ -420,11 +416,21 @@
 {
 	mUseCullCamera = !mUseCullCamera;
+
+	if(mUseCullCamera)
+	{	
+		mWindow->addViewport(mVisualizationCamera, 10, 0.5, 0.5, 1, 1);
+		mWindow->getViewport(1)->setClearEveryFrame(true);
+	}
+	else
+		mWindow->removeViewport(10);
+
 	mSceneMgr->setOption("CullCamera", &mUseCullCamera);
 }
 //-----------------------------------------------------------------------
-void MouseQueryListener::fixCullCamera()
-{
-	mCullCamera->setPosition(mCamera->getPosition());
-	mCullCamera->setOrientation(mCamera->getOrientation());
+void MouseQueryListener::FixVizCamera()
+{
+	mVisualizationCamera->setPosition(mCamera->getPosition());
+	mVisualizationCamera->setOrientation(mCamera->getOrientation());
+	clamp2Terrain(mVisualizationCamera);
 }
 
Index: trunk/VUT/work/TestCullingTerrain/TestCullingTerrainApplication.h
===================================================================
--- trunk/VUT/work/TestCullingTerrain/TestCullingTerrainApplication.h	(revision 93)
+++ trunk/VUT/work/TestCullingTerrain/TestCullingTerrainApplication.h	(revision 94)
@@ -30,5 +30,5 @@
 
     MouseQueryListener(RenderWindow* win, Camera* cam, SceneManager *sceneManager, 
-		CEGUI::Renderer *renderer, TerrainContentGenerator *contentGenerator, Camera *cullCamera);
+		CEGUI::Renderer *renderer, TerrainContentGenerator *contentGenerator, Camera *vizCamera);
 
     ~MouseQueryListener();
@@ -67,7 +67,9 @@
 	void toggleUseCulling();
 	void toggleCullCamera();
-	void fixCullCamera();
+	void FixVizCamera();
 
 protected:
+	void clamp2Terrain(Camera *cam);
+
     bool mLMouseDown, mRMouseDown;     // True if the mouse buttons are down
     SceneManager *mSceneMgr;           // A pointer to the scene manager
@@ -101,5 +103,5 @@
 	bool mUseCullCamera;
 
-	Camera *mCullCamera;
+	Camera *mVisualizationCamera;
 };
 
@@ -127,5 +129,5 @@
 	TerrainContentGenerator *mTerrainContentGenerator;
 
-	Camera *mCullCamera;
+	Camera *mVisualizationCamera;
 	
 private:
Index: trunk/VUT/work/TestCulling/SceneContentGenerator.cpp
===================================================================
--- trunk/VUT/work/TestCulling/SceneContentGenerator.cpp	(revision 87)
+++ trunk/VUT/work/TestCulling/SceneContentGenerator.cpp	(revision 94)
@@ -6,5 +6,4 @@
 */
 #include "SceneContentGenerator.h"
-#include <windows.h>
 
 namespace Ogre {
Index: trunk/VUT/work/TestCulling/TestCullingApplication.cpp
===================================================================
--- trunk/VUT/work/TestCulling/TestCullingApplication.cpp	(revision 93)
+++ trunk/VUT/work/TestCulling/TestCullingApplication.cpp	(revision 94)
@@ -17,5 +17,5 @@
 
 #define WIN32_LEAN_AND_MEAN
-#include "windows.h"
+#include <windows.h>
 
 
@@ -28,5 +28,5 @@
 {
 	// Create the camera
-	mCamera = mSceneMgr->createCamera("PlayerCam");
+	mCamera = mSceneMgr->createCamera("CullCamera");
 
 	// Position it at 500 in Z direction
@@ -112,5 +112,5 @@
 mShowOctree(false),
 mUseCulling(true),
-mUseOptimization(false),
+mUseOptimization(true),
 mUseCullCamera(false)
 {
Index: trunk/VUT/work/TestCulling/TestCullingApplication.h
===================================================================
--- trunk/VUT/work/TestCulling/TestCullingApplication.h	(revision 93)
+++ trunk/VUT/work/TestCulling/TestCullingApplication.h	(revision 94)
@@ -97,5 +97,5 @@
 	bool mUseCullCamera;
 
-	Camera *mCullCamera;
+	Camera *mVisualizationCamera;
 };
 
Index: trunk/VUT/Ogre/include/OgrePlatformHierarchyInterface.h
===================================================================
--- trunk/VUT/Ogre/include/OgrePlatformHierarchyInterface.h	(revision 92)
+++ trunk/VUT/Ogre/include/OgrePlatformHierarchyInterface.h	(revision 94)
@@ -34,16 +34,21 @@
 	GtpVisibility::OcclusionQuery *GetNextOcclusionQuery();
 		
-	/** Sets the current camera.
+	/** Sets the current camera used for the rendering.
 		@param cam the current camera
 	*/
 	void SetCamera(Camera *cam);
-		
+	/** Sets the current camera used for culling.
+		@param cam the current camera
+		@remark the default is the camera used for rendering
+	*/
+	void SetCullCamera(Camera *cullCam);
 	/** Initialises this scene traverser for the current frame.
 	@param root root of the hierarchy
 		@param cam current camera
+		@param cullCam the camera used for culling. If null, the current camera is used
 		@remark convenience method wich calls VisibilitySceneTraverser::initFrame,
 		sets the current camera, and initialises the distance queue.
 	*/
-	void InitFrame(GtpVisibility::HierarchyNode *root, Ogre::Camera *cam);
+	void InitFrame(GtpVisibility::HierarchyNode *root, Camera *cam, Camera *cullCam = NULL);
 	/** Checks if the node is visible from the current view frustum.
 		@param node the current node
@@ -95,4 +100,6 @@
 
 	Camera *mCamera;
+	Camera *mCullCamera;
+
 	AxisAlignedBox mBox;
 	
Index: trunk/VUT/Ogre/src/OgreOctreeHierarchyInterface.cpp
===================================================================
--- trunk/VUT/Ogre/src/OgreOctreeHierarchyInterface.cpp	(revision 93)
+++ trunk/VUT/Ogre/src/OgreOctreeHierarchyInterface.cpp	(revision 94)
@@ -2,8 +2,10 @@
 #include "OgreVisibilityOctreeSceneManager.h"
 #include <OgreOctree.h>
+#include <OgreLogManager.h>
+
 #include <windows.h>
 
 namespace Ogre {
-//namespace GtpVisibility {
+
 //-----------------------------------------------------------------------
 OctreeHierarchyInterface::OctreeHierarchyInterface(SceneManager *sm, RenderSystem *rsys): 
@@ -25,5 +27,6 @@
 	
 	// if not all subtrees are empty
-	if (octree->numNodes() > (int)octree->mNodes.size())
+	//if (octree->numNodes() > (int)octree->mNodes.size())
+	if (!IsLeaf(node))
 	{
 		for(int i=0; i<8; ++i)
@@ -42,13 +45,7 @@
 bool OctreeHierarchyInterface::IsLeaf(GtpVisibility::HierarchyNode *node) const
 {
-	Octree *octant = static_cast<Octree *>(node);
-
-	for(int i=0; i<8; i++)
-	{
-		if (octant->mChildren[(i & 4) >> 2][(i & 2) >> 1][i & 1])
-			return false;
-	}
-
-	return true;
+	Octree *octree = static_cast<Octree *>(node);
+	// HACK: if there are subtrees, they are empty => we are not interested in them
+	return octree->numNodes() == (int)octree->mNodes.size();
 }
 //-----------------------------------------------------------------------
@@ -68,5 +65,5 @@
 	Vector3 mid = ((box->getMinimum() - box->getMaximum()) * 0.5) + box->getMinimum();
 
-	return (mCamera->getDerivedPosition() - mid).squaredLength();
+	return (mCullCamera->getDerivedPosition() - mid).squaredLength();
 }
 //-----------------------------------------------------------------------
Index: trunk/VUT/Ogre/src/OgreVisibilityOctreeSceneManager.cpp
===================================================================
--- trunk/VUT/Ogre/src/OgreVisibilityOctreeSceneManager.cpp	(revision 93)
+++ trunk/VUT/Ogre/src/OgreVisibilityOctreeSceneManager.cpp	(revision 94)
@@ -6,6 +6,4 @@
 #include <OgreCamera.h>
 #include <OgreLogManager.h>
-
-#include <windows.h>
 
 namespace Ogre {
@@ -18,6 +16,5 @@
 	mHierarchyInterface = 
 		new OctreeHierarchyInterface(this, mDestRenderSystem);
-	//visManager->SetCullingManager(GtpVisibility::VisibilityEnvironment::STOP_AND_WAIT_CULLING);
-	
+		
 	//mDisplayNodes = true;
 	//mShowBoundingBoxes = true;
@@ -34,5 +31,9 @@
 void VisibilityOctreeSceneManager::_renderVisibleObjects()
 {
-	mHierarchyInterface->InitFrame(mOctree, mCameraInProgress);
+	Camera *cullCam = NULL;
+
+	if(mCullCamera) cullCam = getCamera("CullCamera");
+	
+	mHierarchyInterface->InitFrame(mOctree, mCameraInProgress, cullCam);
 	mVisibilityManager->GetCullingManager()->InitFrame();
 
Index: trunk/VUT/Ogre/src/OgreSceneNodeHierarchyInterface.cpp
===================================================================
--- trunk/VUT/Ogre/src/OgreSceneNodeHierarchyInterface.cpp	(revision 87)
+++ trunk/VUT/Ogre/src/OgreSceneNodeHierarchyInterface.cpp	(revision 94)
@@ -3,6 +3,4 @@
 #include <OgreCamera.h>
 #include <OgreSceneNode.h>
-
-//#include <windows.h>
 
 namespace Ogre {
Index: trunk/VUT/Ogre/src/OgrePlatformHierarchyInterface.cpp
===================================================================
--- trunk/VUT/Ogre/src/OgrePlatformHierarchyInterface.cpp	(revision 93)
+++ trunk/VUT/Ogre/src/OgrePlatformHierarchyInterface.cpp	(revision 94)
@@ -1,4 +1,4 @@
 #include <OgreCamera.h>
-
+#include <OgreLogManager.h>
 //#include "OgreSolidHalfBoundingBox.h"
 #include "OgreSolidBoundingBox.h"
@@ -11,5 +11,6 @@
 //-----------------------------------------------------------------------
 PlatformHierarchyInterface::PlatformHierarchyInterface(SceneManager *sm, RenderSystem *rsys):
-mSceneManager(sm), mRenderSystem(rsys), mSolidBoundingBox(NULL)/*, mSolidHalfBoundingBox(NULL)*/
+mSceneManager(sm), mRenderSystem(rsys), mSolidBoundingBox(NULL),
+mCamera(NULL), mCullCamera(NULL)
 {
 }
@@ -64,4 +65,9 @@
 }
 //-----------------------------------------------------------------------
+void PlatformHierarchyInterface::SetCullCamera(Ogre::Camera *cullCam)
+{
+	mCullCamera = cullCam;
+}
+//-----------------------------------------------------------------------
 GtpVisibility::OcclusionQuery *PlatformHierarchyInterface::GetNextOcclusionQuery()
 {
@@ -74,5 +80,5 @@
 }
 //-----------------------------------------------------------------------
-void PlatformHierarchyInterface::InitFrame(GtpVisibility::HierarchyNode *root, Camera *cam)
+void PlatformHierarchyInterface::InitFrame(GtpVisibility::HierarchyNode *root, Camera *cam, Camera *cullCam)
 {
 	GtpVisibility::HierarchyInterface::InitFrame(root);
@@ -80,4 +86,9 @@
 
 	SetCamera(cam);
+
+	if(cullCam)
+		SetCullCamera(cullCam);
+	else
+		SetCullCamera(cam);
 }
 //-----------------------------------------------------------------------
@@ -96,5 +107,5 @@
 {
 #ifdef GTP_VISIBILITY_MODIFIED_OGRE
-	return mCamera->isVisible(*GetBoundingBox(node), intersects);
+	return mCullCamera->isVisible(*GetBoundingBox(node), intersects);
 #else
 	return true;
@@ -113,10 +124,13 @@
 	// if node is leaf and was visible => will be rendered anyway.
 	// In this case we can also test with the real geometry.
-	if(mUseOptimization && wasVisible && IsLeaf(node))
+	// if camera for culling is different from camera for rendering => cannot optimize
+	if (mUseOptimization && wasVisible && IsLeaf(node) && (mCamera == mCullCamera))
 	{
+		//LogManager::getSingleton().logMessage("render node\n");
 		RenderNode(node);
 	}
 	else
 	{
+		//LogManager::getSingleton().logMessage("render box\n");
 		RenderBoundingBox(GetBoundingBox(node));
 	}
Index: trunk/VUT/Ogre/src/OgreVisibilityTerrainSceneManager.cpp
===================================================================
--- trunk/VUT/Ogre/src/OgreVisibilityTerrainSceneManager.cpp	(revision 93)
+++ trunk/VUT/Ogre/src/OgreVisibilityTerrainSceneManager.cpp	(revision 94)
@@ -32,5 +32,16 @@
 void VisibilityTerrainSceneManager::_renderVisibleObjects()
 {
-	mHierarchyInterface->InitFrame(mOctree, mCameraInProgress);
+	Camera *cullCam = NULL;
+
+	// if two cameras (one for culling, one for visualization)
+	if(mCullCamera)
+		cullCam = getCamera("CullCamera");
+	
+	if(cullCam && (mCameraInProgress != cullCam))
+		OutputDebugString("using cullcam\n");
+	else
+		OutputDebugString("not using cullcam\n");
+
+	mHierarchyInterface->InitFrame(mOctree, mCameraInProgress, cullCam);
 	mVisibilityManager->GetCullingManager()->InitFrame();
 
Index: trunk/VUT/Ogre/src/OgreSolidBoundingBox.cpp
===================================================================
--- trunk/VUT/Ogre/src/OgreSolidBoundingBox.cpp	(revision 92)
+++ trunk/VUT/Ogre/src/OgreSolidBoundingBox.cpp	(revision 94)
@@ -6,5 +6,5 @@
 #include "OgreCamera.h"
 #include "OgreMaterialManager.h"
-//#include <windows.h>
+
 
 namespace Ogre {
Index: trunk/VUT/Ogre/src/OgreVisibilitySceneManagerDll.cpp
===================================================================
--- trunk/VUT/Ogre/src/OgreVisibilitySceneManagerDll.cpp	(revision 74)
+++ trunk/VUT/Ogre/src/OgreVisibilitySceneManagerDll.cpp	(revision 94)
@@ -34,5 +34,4 @@
 #include <OgreRoot.h>
 
-//#include <windows.h>
 GtpVisibility::VisibilityEnvironment *visEnv;
 GtpVisibility::VisibilityManager *visManager;
Index: trunk/VUT/Ogre/src/OgreVisibilitySceneManager.cpp
===================================================================
--- trunk/VUT/Ogre/src/OgreVisibilitySceneManager.cpp	(revision 87)
+++ trunk/VUT/Ogre/src/OgreVisibilitySceneManager.cpp	(revision 94)
@@ -7,5 +7,4 @@
 #include "OgreVisibilityOptionsManager.h"
 
-//#include <windows.h>
 
 namespace Ogre {