Index: trunk/VUT/GtpVisibility/src/FrustumCullingManager.cpp
===================================================================
--- trunk/VUT/GtpVisibility/src/FrustumCullingManager.cpp	(revision 94)
+++ trunk/VUT/GtpVisibility/src/FrustumCullingManager.cpp	(revision 96)
@@ -8,5 +8,5 @@
 {
 	InitFrame();
-	Ogre::LogManager::getSingleton().logMessage("**** Frustum Culling ****\n");
+	
 	while (!mHierarchyInterface->GetQueue()->empty())
 	{
Index: trunk/VUT/GtpVisibility/src/CoherentHierarchicalCullingManager.cpp
===================================================================
--- trunk/VUT/GtpVisibility/src/CoherentHierarchicalCullingManager.cpp	(revision 95)
+++ trunk/VUT/GtpVisibility/src/CoherentHierarchicalCullingManager.cpp	(revision 96)
@@ -8,6 +8,5 @@
 {
 	InitFrame();
-	Ogre::LogManager::getSingleton().logMessage("**** CHCULL ****\n");
-
+	
 	QueryQueue queryQueue;
 	unsigned int visiblePixels = 0;
@@ -25,5 +24,5 @@
 			queryQueue.pop();
 
-			if (1)//visiblePixels > mVisibilityThreshold)
+			if (visiblePixels > mVisibilityThreshold)
 			{
 				mHierarchyInterface->PullUpVisibility(node);
Index: trunk/VUT/GtpVisibility/src/StopAndWaitCullingManager.cpp
===================================================================
--- trunk/VUT/GtpVisibility/src/StopAndWaitCullingManager.cpp	(revision 94)
+++ trunk/VUT/GtpVisibility/src/StopAndWaitCullingManager.cpp	(revision 96)
@@ -9,5 +9,4 @@
 {
 	InitFrame();
-	Ogre::LogManager::getSingleton().logMessage("*** STOP AND WAIT CULL ****\n");	
 
 	while (!mHierarchyInterface->GetQueue()->empty())
Index: trunk/VUT/Ogre/src/OgreVisibilityOctreeSceneManager.cpp
===================================================================
--- trunk/VUT/Ogre/src/OgreVisibilityOctreeSceneManager.cpp	(revision 94)
+++ trunk/VUT/Ogre/src/OgreVisibilityOctreeSceneManager.cpp	(revision 96)
@@ -21,5 +21,6 @@
 	//mShowBoxes = true;
 
-	mMaxDepth = 20;
+	// TODO: find reasonable value for max depth
+	mMaxDepth = 50;
 }
 //-----------------------------------------------------------------------
@@ -31,11 +32,10 @@
 void VisibilityOctreeSceneManager::_renderVisibleObjects()
 {
-	Camera *cullCam = NULL;
-
-	if(mCullCamera) cullCam = getCamera("CullCamera");
-	
-	mHierarchyInterface->InitFrame(mOctree, mCameraInProgress, cullCam);
+	// two cameras (one for culling, one for rendering)
+	mHierarchyInterface->InitFrame(mOctree, mCameraInProgress, 
+							mCullCamera ? getCamera("CullCamera") : NULL);
 	mVisibilityManager->GetCullingManager()->InitFrame();
 
+	// standard scenemanager rendering without hierarchical culling
 	if(!mUseCulling)
 	{	
Index: trunk/VUT/Ogre/src/OgreVisibilityTerrainSceneManager.cpp
===================================================================
--- trunk/VUT/Ogre/src/OgreVisibilityTerrainSceneManager.cpp	(revision 94)
+++ trunk/VUT/Ogre/src/OgreVisibilityTerrainSceneManager.cpp	(revision 96)
@@ -22,5 +22,5 @@
 	//mDisplayNodes = true;
 	//mShowBoundingBoxes = true;
-	mMaxDepth = 20;
+	mMaxDepth = 50;
 }
 //-----------------------------------------------------------------------
@@ -32,18 +32,10 @@
 void VisibilityTerrainSceneManager::_renderVisibleObjects()
 {
-	Camera *cullCam = NULL;
-
-	// if two cameras (one for culling, one for visualization)
-	if(mCullCamera)
-		cullCam = getCamera("CullCamera");
+	// two cameras (one for culling, one for rendering)
+	mHierarchyInterface->InitFrame(mOctree, mCameraInProgress, 
+							mCullCamera ? getCamera("CullCamera") : NULL);
+	mVisibilityManager->GetCullingManager()->InitFrame();
 	
-	if(cullCam && (mCameraInProgress != cullCam))
-		OutputDebugString("using cullcam\n");
-	else
-		OutputDebugString("not using cullcam\n");
-
-	mHierarchyInterface->InitFrame(mOctree, mCameraInProgress, cullCam);
-	mVisibilityManager->GetCullingManager()->InitFrame();
-
+	// standard scenemanager rendering without hierarchical culling
 	if(!mUseCulling)
 	{	
Index: trunk/VUT/Ogre/src/OgrePlatformOcclusionQuery.cpp
===================================================================
--- trunk/VUT/Ogre/src/OgrePlatformOcclusionQuery.cpp	(revision 87)
+++ trunk/VUT/Ogre/src/OgrePlatformOcclusionQuery.cpp	(revision 96)
@@ -1,4 +1,4 @@
 #include "OgrePlatformOcclusionQuery.h"
-#include <windows.h>
+
 namespace Ogre {
 
Index: trunk/VUT/Ogre/src/OgreVisibilitySceneManager.cpp
===================================================================
--- trunk/VUT/Ogre/src/OgreVisibilitySceneManager.cpp	(revision 94)
+++ trunk/VUT/Ogre/src/OgreVisibilitySceneManager.cpp	(revision 96)
@@ -9,5 +9,5 @@
 
 namespace Ogre {
-//namespace GtpVisibility {
+
 //-----------------------------------------------------------------------
 VisibilitySceneManager::VisibilitySceneManager(GtpVisibility::VisibilityManager *visManager)